// LoadDll.cpp : Initialization functions
#include "StdAfx.h"
#include "StdArx.h"
#include "resource.h"
#include <afxdllx.h>

HINSTANCE _hdllInstance =NULL ;

// This command registers an ARX command.
void AddCommand(const char* cmdGroup, const char* cmdInt, const char* cmdLoc,
				const int cmdFlags, const AcRxFunctionPtr cmdProc, const int idLocal = -1);


// NOTE: DO NOT edit the following lines.
//{{AFX_ADS_FUNC_TABLE
typedef struct {
	char    *name;
	int     (*fptr)();
	BOOL    regFunc;
	BOOL    renderCmd;
} ftblent;

#define ELEMENTS(array) (sizeof(array)/sizeof((array)[0]))

ftblent exfun[] = {
	{"", NULL, FALSE, FALSE },
	{"MtmdLoadDll", MtmdLoadDll, FALSE, FALSE },
}; //}}AFX_ADS_FUNC_TABLE


//{{AFX_ARX_MSG
void InitApplication();
void UnloadApplication();
//}}AFX_ARX_MSG

// NOTE: DO NOT edit the following lines.
//{{AFX_ARX_ADDIN_FUNCS
void RegisterArxApp();
char ThisAppRegistryPath[] = { "Software\\Mansur_Mamkin\\" };
//}}AFX_ARX_ADDIN_FUNCS


////////////////////////////////////////////////////////////////////////////
//
// Define the sole extension module object.
AC_IMPLEMENT_EXTENSION_MODULE(LoadDllDLL);

// Now you can use the CAcModuleResourceOverride class in
// your application to switch to the correct resource instance.
// Please see the ObjectARX Documentation for more details

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point
extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
        _hdllInstance = hInstance;
		// Extension DLL one time initialization
		LoadDllDLL.AttachInstance(hInstance);
		InitAcUiDLL();
	} else if (dwReason == DLL_PROCESS_DETACH) {
		// Terminate the library before destructors are called
		LoadDllDLL.DetachInstance();

	}
	return TRUE;    // ok
}



/////////////////////////////////////////////////////////////////////////////
// ObjectARX EntryPoint
extern "C" AcRx::AppRetCode 
acrxEntryPoint(AcRx::AppMsgCode msg, void* pkt)
{
	switch (msg) {
	case AcRx::kInvkSubrMsg:
		dofun();
		break;
	case AcRx::kUnloadDwgMsg:
		funcunload();
		break;
	case AcRx::kLoadDwgMsg:
		funcload();
		break;
	case AcRx::kInitAppMsg:
		// Comment out the following line if your
		// application should be locked into memory
		acrxDynamicLinker->unlockApplication(pkt);
		acrxDynamicLinker->registerAppMDIAware(pkt);
		InitApplication();
		break;
	case AcRx::kUnloadAppMsg:
		UnloadApplication();
		break;
	}
	return AcRx::kRetOK;
}

// Init this application. Register your
// commands, reactors...
void InitApplication()
{
	// NOTE: DO NOT edit the following lines.
	//{{AFX_ARX_INIT
	RegisterArxApp();
	//}}AFX_ARX_INIT

	// TODO: add your initialization functions

}

// Unload this application. Unregister all objects
// registered in InitApplication.
void UnloadApplication()
{
	// NOTE: DO NOT edit the following lines.
	//{{AFX_ARX_EXIT
	//}}AFX_ARX_EXIT

	// TODO: clean up your application
}

/////////////////////////////////////////////////////////////////////
// funcload(internal)
// This function is called to define all function names in the ADS
// function table.  Each named function will be callable from lisp or
// invokable from another ADS application.
/////////////////////////////////////////////////////////////////////
static int funcload(void)
{
	acutPrintf ("\nMtmdLoadDll 1.0 Copyright  2003 Mansur Mamkin.");

	int i;

	for (i = 1; i < ELEMENTS(exfun); i++) {
		if (!acedDefun(exfun[i].name, i))
			return RTERROR;
		if (exfun[i].regFunc)
			acedRegFunc(exfun[i].fptr, i);
	}

	return RTNORM;
}

//-----------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////
// funcunload(internal)
// This function is called to undefine all function names in the ADS
// function table.  Each named function will be removed from the
// AutoLISP hash table.
/////////////////////////////////////////////////////////////////////
static int funcunload(void)
{
	int i;

	// Undefine each function we defined

	for (i = 1; i < ELEMENTS(exfun); i++) {
		acedUndef(exfun[i].name,i);
	}

	return RTNORM;
}

//-----------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////
// dofun(internal)
// This function is called to invoke the function which has the
// registerd function code that is obtained from acedGetFunCode.
/////////////////////////////////////////////////////////////////////
static int dofun(void)
{
	int val,
	    rc;

	acedRetVoid();

	if ((val = acedGetFunCode()) < 1 || val > ELEMENTS(exfun))
		return RTERROR;

#ifdef RENDER
	if (exfun[val].renderCmd)
		if (!InitRender(false))
			return RTERROR;
#endif

	rc = (*exfun[val].fptr)();

	return ((rc == RTNORM) ? RSRSLT:RSERR);
}


//{{AFX_ARX_REGAPP
void RegisterArxApp()
{
	int strLength;
	if (!_hdllInstance)
		return;

	//
	// Register the application.
	//

	acrxRegisterApp((AcadApp::LoadReasons) (AcadApp::kOnAutoCADStartup),
	                "MtmdLoadDll",
	                ThisAppRegistryPath, 2);

	//
	// Create the registry key for this application
	// (use the variable ThisAppRegistryPath).
	//

	HKEY rkey;
	DWORD result;
	LONG status = RegCreateKeyEx(HKEY_LOCAL_MACHINE,
	                             ThisAppRegistryPath,
	                             0, "",
	                             REG_OPTION_NON_VOLATILE,
	                             KEY_WRITE, NULL, &rkey, &result) ;
	if (ERROR_SUCCESS != status)
		return;

	HKEY prodKey;
	status = RegCreateKeyEx(rkey, "MtmdLoadDll", 0, "",
	                        REG_OPTION_NON_VOLATILE,
	                        KEY_WRITE, NULL, &prodKey, &result);
	RegCloseKey(rkey);
	if (ERROR_SUCCESS != status)
		return;

	// Create the 'Loader' key.
	HKEY loaderKey;
	status = RegCreateKeyEx(prodKey, "Loader", 0, "",
	                        REG_OPTION_NON_VOLATILE,
	                        KEY_WRITE, NULL, &loaderKey, &result);
	if (ERROR_SUCCESS == status) {
		char modulePath[512];
		strLength =::GetModuleFileName(_hdllInstance, modulePath, 512);
		if (strLength)
			RegSetValueEx(loaderKey, "MODULE", 0, REG_SZ,
			              (const unsigned char*)modulePath, strLength + 1);
		RegCloseKey(loaderKey);
	}

	// Create the 'Name' key.
	HKEY nameKey;
	status = RegCreateKeyEx(prodKey, "Name", 0, "",
	                        REG_OPTION_NON_VOLATILE,
	                        KEY_WRITE, NULL, &nameKey, &result);
	if (ERROR_SUCCESS == status) {
		RegSetValueEx(nameKey, "MtmdLoadDll", 0, REG_SZ,
		              (const unsigned char*) "MtmdLoadDll", 12);
		RegCloseKey(nameKey);
	}

	//
	// Finished.
	//

	RegCloseKey(prodKey);
}
//}}AFX_ARX_REGAPP
